﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий блок дисциплин
	/// </summary>
	[DataContract]
	[EntityDescription("DisciplineBlock", "Аудитрия кафедры")]
	public class DisciplineBlock : BaseEntity, IEntitySecurityExtenstion<DisciplineBlock>
	{
        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("Title")]
        public string Title { get; set; }

        [DataMember]
        [MapConfiguration("DisciplineBlockUseForGrouping")]
        public bool DisciplineBlockUseForGrouping { get; set; }

        [DataMember]
        [MapConfiguration("DisciplineBlockOrder")]
        public int DisciplineBlockOrder { get; set; }

        [DataMember]
        [MapConfiguration("DisciplineBlockBlueAsteriskName")]
        public string DisciplineBlockBlueAsteriskName { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("DisciplineBlockId")]
        public virtual List<Discipline> Disciplines { get; set; }

        [ForeignKey("DisciplineBlockId")]
        public virtual List<TimeNorm> TimeNorms { get; set; }

        //-------------------------------------------------------------------------

        public DisciplineBlock SecurityCheck(DisciplineBlock entity, bool allowFullData) => entity;
	}
}