﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий связь преподавателя и должность кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("LecturerPost", "Связь преподавателя и должность кафедры")]
	[EntityDependency("Post", "PostId", "К какой должности относится преподаватель")]
	[EntityDependency("Lecturer", "LecturerId", "К какой должности относится преподаватель")]
	public class LecturerPost : BaseEntity, IEntitySecurityExtenstion<LecturerPost>
	{
		[DataMember]
		[Required]
		[MapConfiguration("LecturerId")]
		public Guid LecturerId { get; set; }

		[DataMember]
		[Required]
		[MapConfiguration("PostId")]
		public Guid PostId { get; set; }

		[DataMember]
		[Required]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[DataMember]
		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[DataMember]
		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }

		//-------------------------------------------------------------------------

		public virtual Post Post { get; set; }

		public virtual Lecturer Lecturer { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public LecturerPost SecurityCheck(LecturerPost entity, bool allowFullData) => entity;
	}
}