﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий должность на кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("Post", "Должность на кафедры")]
	public class Post : BaseEntity, IEntitySecurityExtenstion<Post>
	{
		[DataMember]
		[MapConfiguration("PostName")]
		public string PostName { get; set; }

		[DataMember]
		[MapConfiguration("Hours")]
		public int? Hours { get; set; }

		[DataMember]
		[MapConfiguration("Order")]
		public int Order { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("PostId")]
		public virtual List<EmployeePost> EmployeePosts { get; set; }

		[ForeignKey("PostId")]
		public virtual List<LecturerPost> LecturerPosts { get; set; }

		//-------------------------------------------------------------------------

		public Post SecurityCheck(Post entity, bool allowFullData) => entity;
	}
}