﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий норму времени
	/// </summary>
	[DataContract]
	[EntityDescription("TimeNorm", "Норма времени")]
	[EntityDependency("DisciplineBlock", "DisciplineBlockId", "Блок дисцпилн, к которому относится норма")]
	public class TimeNorm : BaseEntity, IEntitySecurityExtenstion<TimeNorm>
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("DisciplineBlockId")]
        public Guid DisciplineBlockId { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormName")]
        public string TimeNormName { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormShortName")]
        public string TimeNormShortName { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormOrder")]
        public int TimeNormOrder { get; set; }

        [DataMember]
        [MapConfiguration("TimeNormEducationDirectionQualification")]
        public int? TimeNormEducationDirectionQualification { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("KindOfLoadName")]
        public string KindOfLoadName { get; set; }

        [DataMember]
        [MapConfiguration("KindOfLoadAttributeName")]
        public string KindOfLoadAttributeName { get; set; }

        [DataMember]
        [MapConfiguration("KindOfLoadBlueAsteriskName")]
        public string KindOfLoadBlueAsteriskName { get; set; }

        [DataMember]
        [MapConfiguration("KindOfLoadBlueAsteriskAttributeName")]
        public string KindOfLoadBlueAsteriskAttributeName { get; set; }

        [DataMember]
        [MapConfiguration("KindOfLoadBlueAsteriskPracticName")]
        public string KindOfLoadBlueAsteriskPracticName { get; set; }

        [DataMember]
        [MapConfiguration("UseInLearningProgress")]
        public bool UseInLearningProgress { get; set; }

        [DataMember]
        [MapConfiguration("UseInSite")]
        public bool UseInSite { get; set; }

        //-------------------------------------------------------------------------

        public virtual DisciplineBlock DisciplineBlock { get; set; }

        //-------------------------------------------------------------------------

        [ForeignKey("TimeNormId")]
        public virtual List<AcademicPlanRecordTimeNormHour> AcademicPlanRecordTimeNormHours { get; set; }

        //-------------------------------------------------------------------------

        public TimeNorm SecurityCheck(TimeNorm entity, bool allowFullData) => entity;
    }
}