﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Security
{
	/// <summary>
	/// Класс, описывающий возможные действия для роли
	/// </summary>
	[DataContract]
    [EntityDescription("Access", "Доступные действия для ролей")]
    [EntityDependency("Role", "RoleId", "Доступные дейсвтиия создаются под конкретную роль")]
    public class Access : BaseEntity, IEntitySecurityExtenstion<Access>
    {
        [DataMember]
        [Required]
        [MapConfiguration("RoleId")]
        public Guid RoleId { get; set; }

        [DataMember]
        [Required]
        [MapConfiguration("AccessOperation")]
        public AccessOperation AccessOperation { get; set; }

        [DataMember]
        [Required]
        [MapConfiguration("AccessType")]
        public AccessType AccessType { get; set; }

        //-------------------------------------------------------------------------

        public virtual Role Role { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        public Access SecurityCheck(Access entity, bool allowFullData)
		{
            if (!allowFullData)
			{
                entity.AccessType = AccessType.View;
			}
            return entity;
		}
	}
}