﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Security
{
	/// <summary>
	/// Класс, описывающий роль в системе
	/// </summary>
	[DataContract]
    [EntityDescription("Role", "Роли в системе")]
    public class Role : BaseEntity, IEntitySecurityExtenstion<Role>
    {
        [DataMember]
        [Required]
        [MapConfiguration("RoleName")]
        public string RoleName { get; set; }

        [DataMember]
        [MapConfiguration("RolePriority")]
        public int RolePriority { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("RoleId")]
        public virtual List<Access> Access { get; set; }

        [ForeignKey("RoleId")]
        public virtual List<UserRole> UserRoles { get; set; }

        //-------------------------------------------------------------------------

        public Role SecurityCheck(Role entity, bool allowFullData) => entity;

    }
}