﻿using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
    /// <summary>
    /// Получение часов по норме времени для записи учебного плана
    /// </summary>
    public class AcademicPlanRecordTimeNormHourGetBindingModel : GetBindingModel
    {
        public Guid? AcademicPlanRecordId { get; set; }

        public Guid? TimeNormId { get; set; }
    }

    /// <summary>
    /// Сохранение часов по норме времени для записи учебного плана
    /// </summary>
    public class AcademicPlanRecordTimeNormHourSetBindingModel : SetBindingModel
    {
        [Required(ErrorMessage = "required")]
        [MapConfiguration("AcademicPlanRecordId")]
        public Guid AcademicPlanRecordId { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("TimeNormId")]
        public Guid TimeNormId { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("PlanHours")]
        public decimal PlanHours { get; set; }
    }
}