﻿using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
	/// <summary>
	/// Получение связи сотрудника с должностью
	/// </summary>
	public class EmployeePostGetBindingModel : GetBindingModel
	{
		public Guid? EmployeeId { get; set; }

		public Guid? PostId { get; set; }
	}

	/// <summary>
	/// Сохранение связи сотрудника с должностью
	/// </summary>
	public class EmployeePostSetBindingModel : SetBindingModel
	{
		[Required(ErrorMessage = "required")]
		[MapConfiguration("EmployeeId")]
		public Guid EmployeeId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("PostId")]
		public Guid PostId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }
	}
}