﻿using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
	/// <summary>
	/// Получение связи преподавателя с должностью
	/// </summary>
	public class LecturerPostGetBindingModel : GetBindingModel
	{
		public Guid? LecturerId { get; set; }

		public Guid? PostId { get; set; }
	}

	/// <summary>
	/// Сохранение связи преподавателя с должностью
	/// </summary>
	public class LecturerPostSetBindingModel : SetBindingModel
	{
		[Required(ErrorMessage = "required")]
		[MapConfiguration("LecturerId")]
		public Guid LecturerId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("PostId")]
		public Guid PostId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }
	}
}