﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.ViewModels;

namespace DepartmentBusinessLogic.ViewModels
{
	/// <summary>
	/// Список блоков дисциплин
	/// </summary>
	public class DisciplineBlockListViewModel : ListViewModel<DisciplineBlockViewModel> { }

	/// <summary>
	/// Элемент блок дисциплины
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Дисципилны", Order = 1, ParentPropertyName = "DisciplineBlockId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlDisciplineList, DepartmentWindowsDesktop")]
	[ViewModelControlElementDependenceEntity(Title = "Нормы времени", Order = 1, ParentPropertyName = "DisciplineBlockId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlTimeNormList, DepartmentWindowsDesktop")]
	public class DisciplineBlockViewModel : ElementViewModel
	{
		[ViewModelControlListProperty("Название блока")]
		[ViewModelControlElementProperty("Название блока", ControlType.ControlString, MustHaveValue = true)]
		[MapConfiguration("Title")]
		public string Title { get; set; }

		[ViewModelControlElementProperty("Используется для группровки в расчетах", ControlType.ControlBool, MustHaveValue = true)]
		[MapConfiguration("DisciplineBlockUseForGrouping")]
		public bool DisciplineBlockUseForGrouping { get; set; }

		[ViewModelControlListProperty("Порядок", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Порядок", ControlType.ControlInt, MustHaveValue = true)]
		[MapConfiguration("DisciplineBlockOrder")]
		public int DisciplineBlockOrder { get; set; }

		[ViewModelControlElementProperty("Назв. в планах", ControlType.ControlString)]
		[MapConfiguration("DisciplineBlockBlueAsteriskName")]
		public string DisciplineBlockBlueAsteriskName { get; set; }

		public override string ToString() => Title;
	}
}
