﻿using DepartmentBusinessLogic.Interfaces;
using DepartmentDatabaseImplementation.Implementations;
using ModuleTools.BusinessLogics;
using ModuleTools.Interfaces;

namespace DepartmentDatabaseImplementation
{
	public class DepartmentImplementationExtensions : IImplementationExtension
	{
		public void RegisterServices()
		{
			DependencyManager.Instance.RegisterType<IPostService, PostService>();

			DependencyManager.Instance.RegisterType<IEmployeeService, EmployeeService>();
			DependencyManager.Instance.RegisterType<IEmployeePostService, EmployeePostService>();

			DependencyManager.Instance.RegisterType<IClassroomService, ClassroomService>();

			DependencyManager.Instance.RegisterType<IDisciplineBlockService, DisciplineBlockService>();
			DependencyManager.Instance.RegisterType<IDisciplineService, DisciplineService>();

			DependencyManager.Instance.RegisterType<ILecturerAcademicDegreeService, LecturerAcademicDegreeService>();
			DependencyManager.Instance.RegisterType<ILecturerAcademicRankService, LecturerAcademicRankService>();
			DependencyManager.Instance.RegisterType<ILecturerService, LecturerService>();
			DependencyManager.Instance.RegisterType<ILecturerPostService, LecturerPostService>();

			DependencyManager.Instance.RegisterType<IEducationDirectionService, EducationDirectionService>();

			DependencyManager.Instance.RegisterType<ITimeNormService, TimeNormService>();

			DependencyManager.Instance.RegisterType<IAcademicPlanService, AcademicPlanService>();
			DependencyManager.Instance.RegisterType<IAcademicPlanRecordService, AcademicPlanRecordService>();
			DependencyManager.Instance.RegisterType<IAcademicPlanRecordTimeNormHourService, AcademicPlanRecordTimeNormHourService>();
		}
	}
}