﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	public partial class ControlLecturerList :
		GenericControlEntityList<LecturerGetBindingModel, LecturerSetBindingModel, LecturerListViewModel, LecturerViewModel, LecturerBusinessLogic>,
		IGenericControlEntityList
	{
		public ControlLecturerList()
		{
			InitializeComponent();
			Title = "Преподаватели";
			ControlId = new Guid("9e39dbb5-3b29-4971-9574-b4c13d5470c6");
			AccessOperation = AccessOperation.Преподаватели;
			ControlViewEntityElement = new ControlLecturerElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlLecturerList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};
	}
}